use crate::prelude::*;
use macro_rules_attribute::apply;


#[apply(DefDer)]
#[apply(ConfigFile)]
#[derive(Copy, Default)]
pub enum Algorithm {
    Rsa,
    Brainpool,
    Secp,
    #[default]
    ED25519,
}


#[apply(DefDer)]
#[apply(ConfigFile)]
#[derive(Copy, Default)]
#[serde(deny_unknown_fields)]
pub enum Strength {
    Weak,
    Middle,
    #[default]
    Strong,
}

impl Strength {
    pub fn rsabits(self) -> u32 {
        match self {
            Self::Weak => RsaStrength::Weak as u32,
            Self::Middle => RsaStrength::Middle as u32,
            Self::Strong => RsaStrength::Strong as u32,
        }
    }
}
